org.apache.commons.io.input

## Class UnsynchronizedByteArrayInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.io.input.UnsynchronizedByteArrayInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class UnsynchronizedByteArrayInputStream
      extends InputStream

  This is an alternative to `ByteArrayInputStream` which removes the synchronization overhead for non-concurrent access; as such this class is not thread-safe.

  To build an instance, see `UnsynchronizedByteArrayInputStream.Builder`.

  Since:
    2.7
  See Also:
    `ByteArrayInputStream`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `UnsynchronizedByteArrayInputStream.Builder` Builds a new `UnsynchronizedByteArrayInputStream` instance.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `END_OF_STREAM` The end of stream marker.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UnsynchronizedByteArrayInputStream(byte[] data)` Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.
    `UnsynchronizedByteArrayInputStream(byte[] data, int offset)` Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.
    `UnsynchronizedByteArrayInputStream(byte[] data, int offset, int length)` Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `static UnsynchronizedByteArrayInputStream.Builder` | `builder()` Constructs a new `UnsynchronizedByteArrayInputStream.Builder`.
    `void` | `mark(int readlimit)`
    `boolean` | `markSupported()`
    `int` | `read()`
    `int` | `read(byte[] dest)`
    `int` | `read(byte[] dest, int off, int len)`
    `void` | `reset()`
    `long` | `skip(long n)`

    - ### Methods inherited from class java.io.InputStream

      `close`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### END_OF_STREAM

          public static final int END_OF_STREAM

      The end of stream marker.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### UnsynchronizedByteArrayInputStream

          @Deprecated
          public UnsynchronizedByteArrayInputStream(byte[] data)

      Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.
      Creates a new byte array input stream.
      Parameters:
        `data` - the buffer

    - #### UnsynchronizedByteArrayInputStream

          @Deprecated
          public UnsynchronizedByteArrayInputStream(byte[] data,
                                                                int offset)

      Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.
      Creates a new byte array input stream.
      Parameters:
        `data` - the buffer
        `offset` - the offset into the buffer
      Throws:
        `IllegalArgumentException` - if the offset is less than zero

    - #### UnsynchronizedByteArrayInputStream

          @Deprecated
          public UnsynchronizedByteArrayInputStream(byte[] data,
                                                                int offset,
                                                                int length)

      Deprecated. Use `builder()`, `UnsynchronizedByteArrayInputStream.Builder`, and `UnsynchronizedByteArrayInputStream.Builder.get()`.
      Creates a new byte array input stream.
      Parameters:
        `data` - the buffer
        `offset` - the offset into the buffer
        `length` - the length of the buffer
      Throws:
        `IllegalArgumentException` - if the offset or length less than zero

  - ### Method Detail

    - #### builder

          public static UnsynchronizedByteArrayInputStream.Builder builder()

      Constructs a new `UnsynchronizedByteArrayInputStream.Builder`.
      Returns:
        a new `UnsynchronizedByteArrayInputStream.Builder`.

    - #### available

          public int available()

      Overrides:
        `available` in class `InputStream`

    - #### mark

          public void mark(int readlimit)

      Overrides:
        `mark` in class `InputStream`

    - #### markSupported

          public boolean markSupported()

      Overrides:
        `markSupported` in class `InputStream`

    - #### read

          public int read()

      Specified by:
        `read` in class `InputStream`

    - #### read

          public int read(byte[] dest)

      Overrides:
        `read` in class `InputStream`

    - #### read

          public int read(byte[] dest,
                          int off,
                          int len)

      Overrides:
        `read` in class `InputStream`

    - #### reset

          public void reset()

      Overrides:
        `reset` in class `InputStream`

    - #### skip

          public long skip(long n)

      Overrides:
        `skip` in class `InputStream`

Copyright © 2002–2023 The Apache Software Foundation. All rights reserved.